Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -1276,185 +3282,214 @@
 unsigned int p       = procid & ((1<<P_WIDTH)-1);
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] enters for path %s\n",
-        x, y, p, pathname );
-#endif
-
-    // checking creat argument
-    if ( creat )
-    {
-        _printf("\n[FAT ERROR] in _fat_open() : create not supported yet\n");
-        return -1;
-    }
-
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] enters for file <%s> "
+        " / bytes = %x / seek = %x\n",
+        x , y , p , inode->name , count , seek );
+#endif
+
+    // chek if file size must be incremented
+    // and allocate new clusters from FAT if required
+    unsigned int old_size = inode->size;
+    unsigned int new_size = seek + count;
+    if ( new_size > old_size )
+    {
+        // update size in inode
+        inode->size = new_size;
+ 
+        // compute current and required numbers of clusters
+        unsigned old_clusters = old_size >> 12;
+        if ( old_size & 0xFFF ) old_clusters++;
+
+        unsigned new_clusters = new_size >> 12;
+        if ( new_size & 0xFFF ) new_clusters++;
+
+        // allocate new clusters from FAT if required
+        if ( new_clusters > old_clusters )
+        {
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] allocates new clusters for file <%s>"
+        " / current = %d / required = %d\n",
+        x , y , p , inode->name , old_clusters , new_clusters );
+#endif
+            // allocate missing clusters
+            if ( _clusters_allocate( inode,
+                                     old_clusters,
+                                     new_clusters - old_clusters ) )
+            {
+                _spin_lock_release( &_fat.fat_lock );
+                _printf("\n[FAT ERROR] in _fat_write() : no free clusters"
+                        " for file <%s>\n", _fat.fd[fd_id].inode->name );
+                return -5;
+            }
+        }
+         
+        // update parent directory entry (size an cluster index)
+        if ( _update_dir_entry( inode ) )
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_write() : cannot update parent directory entry"
+                    " for file <%s>\n", _fat.fd[fd_id].inode->name );
+            return -6;
+        }
+            
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] updates size for file <%s> / size = %x\n",
+        x , y , p , inode->name , (new_size - old_size) );
+#endif
+
+    }
+
+    // compute first_cluster_id and first_byte_to_move 
+    unsigned int first_cluster_id   = seek >> 12;
+    unsigned int first_byte_to_move = seek & 0xFFF;   
+
+    // compute last_cluster and last_byte_to_move 
+    unsigned int last_cluster_id   = (seek + count - 1) >> 12;   
+    unsigned int last_byte_to_move = (seek + count - 1) & 0xFFF;
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] starts loop on clusters for file <%s>\n"
+        "  first_cluster_id = %d / first_byte_to_move = %x"
+        " / last_cluster_id = %d / last_byte_to_move = %x\n",
+        x , y , p , inode->name ,
+        first_cluster_id , first_byte_to_move , last_cluster_id , last_byte_to_move );
+#endif
+
+    // loop on all clusters covering the requested transfer
+    unsigned int cluster_id;
+    unsigned int done = 0;
+    for ( cluster_id = first_cluster_id ; cluster_id <= last_cluster_id ; cluster_id++ )
+    {
+        // get pointer on one 4K buffer in File-Cache 
+        unsigned char*     cbuf;
+        fat_cache_desc_t*  pdesc;
+        if ( _get_buffer_from_cache( inode,   
+                                     cluster_id,  
+                                     &pdesc ) )   
+        {
+            _spin_lock_release( &_fat.fat_lock );
+            _printf("\n[FAT ERROR] in _fat_write() : cannot load file <%s>\n",
+                    inode->name );
+            return -7;
+        }
+        
+        cbuf         = pdesc->buffer;
+        pdesc->dirty = 1;
+   
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] move cluster_id %d to Cache-file <%s>\n",
+        x , y , p , cluster_id, inode->name );
+#endif
+
+        // compute memcpy arguments
+        unsigned char* source = (unsigned char*)buffer + done;
+        unsigned char* dest;
+        unsigned int   nbytes;
+        if ( (cluster_id == first_cluster_id) && (cluster_id == last_cluster_id) )
+        {
+            dest   = cbuf + first_byte_to_move; 
+            nbytes = last_byte_to_move - first_byte_to_move + 1;
+        }
+        else if ( cluster_id == first_cluster_id )
+        {
+            dest   = cbuf + first_byte_to_move; 
+            nbytes = 4096 - first_byte_to_move;
+        }
+        else if ( cluster_id == last_cluster_id )
+        {
+            dest   = cbuf; 
+            nbytes = last_byte_to_move + 1;
+        }
+        else
+        {
+            dest   = cbuf; 
+            nbytes = 4096;
+        }
+
+        //move date
+        memcpy( dest , source , nbytes ); 
+        done = done + nbytes;
+
+    } // end for clusters
+
+    // update seek
+    _fat.fd[fd_id].seek += done;
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_write() : P[%d,%d,%d] store file <%s> into Cache-File\n",
+        x , y , p , inode->name );
+#endif
+
+    // release lock
+    _spin_lock_release( &_fat.fat_lock );
+
+    return done;
+} // end _fat_write()
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the "giet_fat_lseek()" system call.
+// It repositions the seek in the file descriptor "fd_id", according to
+// the "seek" and "whence" arguments.
+// It has the same semantic as the UNIX lseek() function.
+// Accepted values for whence are SEEK_SET and SEEK_CUR.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns new seek value (bytes) if success.
+// Returns negative value if error:
+//   -1  : "FAT not initialised"
+//   -2  : "Illegal file descriptor"
+//   -3  : "File not open"
+//   -4  : "Illegal whence argument"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_lseek( unsigned int fd_id,
+                unsigned int seek,
+                unsigned int whence )
+{
     // checking FAT initialised
     if( _fat.initialised != FAT_INITIALISED )
     {
-        _printf("\n[FAT ERROR] in _fat_open() : FAT not initialised\n");
+        _printf("\n[FAT ERROR] in _fat_lseek() : FAT not initialised\n");
         return -1;
     }
-    // takes the FAT lock for exclusive access
+
+    // check fd_id overflow
+    if ( fd_id >= GIET_OPEN_FILES_MAX )
+    {
+        _printf("\n[FAT ERROR] in _fat_lseek() : illegal file descriptor\n");
+        return -2;
+    }
+
+    // takes lock
     _spin_lock_acquire( &_fat.fat_lock );
 
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] takes the FAT lock\n",
-        x, y, p );
-#endif
- 
-    // Scan the directories, starting from the root directory (cluster 2)
-    // - The get_name_from_path() function extracts (successively) 
-    //   each directory name from the pathname, and store it in name[] buffer
-    // - The _scan_directory() function scan one (or several) cluster(s) containing 
-    //   a directory looking for name[], and return the cluster index
-    //   corresponding to the directory/file found.
-    nb_read     = 0;
-    cluster     = 2;
-    last_name   = 0;
-    while ( get_name_from_path( pathname, name, &nb_read) )
-    {
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] search file/dir %s\n",
-        x, y, p, name );
-#endif
-
-        // test if we reach the last name (file name)
-        if( pathname[nb_read] == 0 )  
-        {
-            last_name   = 1;
-            dir_cluster = cluster;   // this is the lowest directory
-        }
-
-        // scan current directory
-        cluster = _scan_directory( use_irq , cluster , name , &file_size , &lba );
-
-        if( cluster == END_OF_CHAIN_CLUSTER && last_name && creat )
-        {
-            cluster = _fat_create( name, 1, dir_cluster );
-        }
-        else if ( cluster == END_OF_CHAIN_CLUSTER )
-        {
-            _printf("\n[FAT ERROR] in _fat_open() cannot found %s\n", name );
-            _spin_lock_release( &_fat.fat_lock );
-            return -1;
-        }
-    }
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] P[%d,%d,%d] in _fat_open() : cluster for %s = %x\n",
-       x, y, p, pathname, cluster );
-#endif
-
-    // check the next value for cluster index found
-    unsigned next = _get_next_cluster( use_irq , cluster );
-
-    if ( (next != BAD_CLUSTER) && (next != FREE_CLUSTER) )
-    {
-        // Search an empty slot scanning open file descriptors array
-        fd_id = 0;
-        while ( _fat.fd[fd_id].used != 0 && fd_id < GIET_OPEN_FILES_MAX )
-        {
-            fd_id++;
-        }
-
-        // set file descriptor if found empty slot
-        if ( fd_id < GIET_OPEN_FILES_MAX )
-        {
-            _fat.fd[fd_id].used          = 1;
-            _fat.fd[fd_id].first_cluster = cluster;
-            _fat.fd[fd_id].file_size     = file_size;
-            _fat.fd[fd_id].lba_dir_entry = lba;
-            _strcpy( _fat.fd[fd_id].name, pathname );
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_open() : P[%d,%d,%d] exit : fd = %d for file %s\n",
-        x, y, p, fd_id, pathname );
-#endif
-
-            // release FAT lock
-            _spin_lock_release( &_fat.fat_lock );
-
-            return fd_id;
-        }
-        else
-        {
-            _printf("\n[FAT ERROR] in _fat_open() for file %s : fd array full\n", 
-                    pathname );
-            _spin_lock_release( &_fat.fat_lock );
-            return -1;
-        }
-    }
+    // check file open
+    if ( _fat.fd[fd_id].allocated == 0 )
+    {
+        _spin_lock_release( &_fat.fat_lock );
+        _printf("\n[FAT ERROR] in _fat_lseek() : file not open\n");
+        return -3;
+    }
+
+    unsigned int  new_seek;
+
+    // compute new seek
+    if      ( whence == SEEK_CUR ) new_seek = _fat.fd[fd_id].seek + seek;
+    else if ( whence == SEEK_SET ) new_seek = seek;
     else
     {
-        _printf("\n[FAT ERROR] in _fat_open() for file %s : bad cluster\n",
-                pathname );
         _spin_lock_release( &_fat.fat_lock );
-        return -1;
-    }
-} // end _fat_open()
-
-///////////////////////////////////////////////////////////////////////////////
-// For an open file, identified by the file descriptor index, transfer 
-// an integer number of sectors from block device to a memory buffer.
-// If the number of requested sectors exceeds the file size, it is reduced.
-///////////////////////////////////////////////////////////////////////////////
-// Returns number of sectors transfered if success, < 0 if error.
-///////////////////////////////////////////////////////////////////////////////
-int _fat_read( unsigned int use_irq,    // use descheduling mode if possible
-               unsigned int fd_id,      // file descriptor
-               void*        buffer,     // target buffer base address
-               unsigned int count,      // number of sector to read
-               unsigned int offset )    // nuber of sectors to skip in file
-{
-    unsigned int spc = _fat.sectors_per_cluster;
-
-    unsigned int file_size;         // number of bytes in file
-    unsigned int file_sectors;      // number of sectors in file
-    unsigned int total_sectors;     // actual number of sectors to be transfered
-    unsigned int cluster;           // cluster index 
-    unsigned int clusters_to_skip;  // number of clusters to skip because offset
-    unsigned int sectors_to_skip;   // number of sectors to skip in first iteration
-
-    // arguments checking
-    if ( fd_id >= GIET_OPEN_FILES_MAX )
-    { 
-        _printf("\n[FAT ERROR] in _fat_read() : illegal file descriptor index\n");
-        return -1;
-    }
-    if ( _fat.fd[fd_id].used != 1 )
-    {
-        _printf("\n[FAT ERROR] in _fat_read() : file not open\n");
-        return -1;
-    }
-    if ( ((unsigned int)buffer & 0x1FF) != 0 )
-    {
-        _printf("\n[FAT ERROR] in _fat_read() : memory buffer not sector aligned\n");
-        return -1;
-    }
-
-    // compute file size as a number of sectors 
-    file_size    = _fat.fd[fd_id].file_size;
-    if ( file_size & 0x1FF ) file_sectors = (file_size >> 9) + 1;
-    else                     file_sectors = (file_size >> 9); 
-
-    if ( offset >= file_sectors )
-    {
-        _printf("\n[FAT ERROR] offset larger than number of sectors\n");
-        return -1;
-    }
-
-    // compute total number of sectors to read
-    if ( file_sectors < (offset + count) ) total_sectors = file_sectors - offset;
-    else                                   total_sectors = count;
-
-    // compute clusters and sectors to be skipped
-    clusters_to_skip = offset / spc;
-    sectors_to_skip  = offset % spc;
-    
-    // get first cluster index 
-    cluster = _fat.fd[fd_id].first_cluster;
+        _printf("\n[FAT ERROR] in _fat_user_lseek() : illegal whence valuel\n");
+        return -4;
+    }
+
+    // update file descriptor offset 
+    _fat.fd[fd_id].seek = new_seek;
 
 #if GIET_DEBUG_FAT
@@ -1464,108 +3499,42 @@
 unsigned int p       = procid & ((1<<P_WIDTH)-1);
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_read() : P[%d,%d,%d] enters for file %s\n"
-        " - buffer vbase     = %x\n"
-        " - skipped sectors  = %x\n"
-        " - read sectors     = %x\n"
-        " - first cluster    = %x\n"
-        " - skipped clusters = %x\n",
-        x, y, p, _fat.fd[fd_id].name, (unsigned int)buffer,
-        offset, count, cluster, clusters_to_skip );
-#endif
-
-    // compute index of first cluster to be loaded
-    while ( clusters_to_skip )
-    {
-        cluster = _get_next_cluster( use_irq , cluster );
-        clusters_to_skip--;
-    }
-
-    // variables used in the loop on clusters
-    int             todo_sectors;   // number of sectors still to be loaded
-    unsigned int    lba;            // first sector index on device
-    unsigned int    iter_sectors;   // number of sectors to load in iteration
-    unsigned int    dst;            // pointer on target buffer
-
-    // initialize these variables for the first iteration 
-    todo_sectors  = total_sectors;
-    dst           = (unsigned int)buffer;
-    lba           = cluster_to_lba(cluster) + sectors_to_skip;
-    if( total_sectors < (spc - sectors_to_skip) ) iter_sectors = total_sectors;
-    else                                          iter_sectors = spc - sectors_to_skip; 
-
-    // loop on the clusters: one IOC access per cluster
-    while ( todo_sectors > 0 )
-    {
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_read() : P[%d,%d,%d] makes an IOC read\n"
-        "  cluster = %x / buffer = %x / lba = %x / sectors = %d\n",
-        x, y, p, cluster, dst, lba, iter_sectors );
-#endif
-
-        if( _fat_ioc_access( use_irq,
-                             1,                 // read
-                             lba, 
-                             dst,               // buffer address
-                             iter_sectors ) )   // number of sectors
-        {
-            _printf("\n[FAT ERROR] in _fat_read() cannot load block %x", lba );
-            return -1;
-        }
-         
-        // update variables for next iteration
-        cluster      = _get_next_cluster( use_irq , cluster );
-        todo_sectors = todo_sectors - iter_sectors;
-        dst          = dst + (iter_sectors << 9);
-        lba          = cluster_to_lba(cluster);
-        if ( todo_sectors > spc ) iter_sectors = spc;
-        else                      iter_sectors = todo_sectors;
-    }
-         
-    // returns number of sectors actually transfered
-    return total_sectors;
-
-}  // end _fat_read() 
-
-///////////////////////////////////////////////////////////////////////////////
-// For an open file, identified by the file descriptor index, transfer 
-// an integer number of sectors from a memory buffer to block device.
-// Allocate new clusters if the offset+count larger than current file size,
-// but the offset should be smaller than the current file size...
-///////////////////////////////////////////////////////////////////////////////
-// Returns number of sectors written if success, < 0 if error.
-///////////////////////////////////////////////////////////////////////////////
-int _fat_write( unsigned int use_irq,    // use descheduling mode if possible
-                unsigned int fd_id,      // file descriptor
-                void*        buffer,     // target buffer base address
-                unsigned int count,      // number of sector to write
-                unsigned int offset )    // nuber of sectors to skip in file
-{
-
-    unsigned int spc = _fat.sectors_per_cluster;
-
-    unsigned int file_size;         // number of bytes in file
-    unsigned int file_sectors;      // number of sectors in file
-    unsigned int cluster;           // cluster index 
-    unsigned int clusters_to_skip;  // number of clusters to skip because offset
-    unsigned int sectors_to_skip;   // number of sectors to skip in first iteration
-    unsigned int allocate;          // need allocate or not
-    unsigned int current_cluster;   // number of cluster allocated to the file
-    unsigned int required_cluster;  // number of cluster needed for the write
-
-    // compute file size as a number of sectors 
-    file_size    = _fat.fd[fd_id].file_size;
-    if ( file_size & 0x1FF ) file_sectors = (file_size >> 9) + 1;
-    else                     file_sectors = (file_size >> 9); 
-
-    // Compute the number of clusters occupied by the file
-    current_cluster = file_sectors / spc;
-
-    // Compute the number of clusters that will occupy the file (after fat_write)
-    required_cluster = (count + offset) / spc;
-
-    // Check if we need to allocate new cluster(s) for the file  
-    allocate = ( required_cluster > current_cluster );
+_printf("\n[DEBUG FAT] _fat_lseek() : P[%d,%d,%d] set seek = %x for file <%s>\n",
+        x , y , p , new_seek , _fat.fd[fd_id].inode->name );
+#endif
+
+    // release lock
+    _spin_lock_release( &_fat.fat_lock );
+
+    return new_seek;
+}  // end _fat_lseek()
+
+
+
+/////////////////////////////////////////////////////////////////////////////////
+// The following function implements the giet_fat_remove() system call. 
+// It deletes the file/directory identified by the "pathname" argument from 
+// the file system, if the remove condition is fulfilled (directory empty,
+// or file not referenced).
+// All clusters allocated in the block device DATA region are released.
+// The FAT region is updated on the block device.
+// The Inode-Tree is updated.
+// The associated File_Cache is released.
+// The Fat_Cache is updated.
+/////////////////////////////////////////////////////////////////////////////////
+// Returns 0 if success.
+// Returns negative value if error
+//   -1  : "FAT not initialised"
+//   -2  : "File/Directory not found"
+//   -3  : "Name too long in path"
+//   -4  : "Has the wrong type"
+//   -5  : "File still open"
+//   -6  : "Cannot scan directory"
+//   -7  : "Directory not empty"
+//   -8  : "Cannot remove file/dir from FS"
+/////////////////////////////////////////////////////////////////////////////////
+int _fat_remove( char*        pathname,
+                 unsigned int should_be_dir )
+{
+    fat_inode_t*  inode;            // searched file inode pointer
 
 #if GIET_DEBUG_FAT
